<a id="mypy-boto3-pinpoint"></a>

# mypy-boto3-pinpoint

[![PyPI - mypy-boto3-pinpoint](https://img.shields.io/pypi/v/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-pinpoint?color=blue)](https://pypistats.org/packages/mypy-boto3-pinpoint)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Pinpoint 1.21.30](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/pinpoint.html#Pinpoint)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.5.5](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-pinpoint docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-pinpoint](#mypy-boto3-pinpoint)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Pinpoint`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `Pinpoint` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[pinpoint]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[pinpoint]'


# standalone installation
python -m pip install mypy-boto3-pinpoint
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-pinpoint
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[pinpoint]` in your environment:

```bash
python -m pip install 'boto3-stubs[pinpoint]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[pinpoint]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[pinpoint]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[pinpoint]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[pinpoint]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[pinpoint]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[pinpoint]` in your environment:

```bash
python -m pip install 'boto3-stubs[pinpoint]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[pinpoint]` in your environment:

```bash
python -m pip install 'boto3-stubs[pinpoint]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`PinpointClient` provides annotations for `boto3.client("pinpoint")`.

```python
from boto3.session import Session

from mypy_boto3_pinpoint import PinpointClient

client: PinpointClient = Session().client("pinpoint")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="literals"></a>

### Literals

`mypy_boto3_pinpoint.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_pinpoint.literals import (
    ActionType,
    AlignmentType,
    AttributeTypeType,
    ButtonActionType,
    CampaignStatusType,
    ChannelTypeType,
    DeliveryStatusType,
    DimensionTypeType,
    DurationType,
    EndpointTypesElementType,
    FilterTypeType,
    FormatType,
    FrequencyType,
    IncludeType,
    JobStatusType,
    LayoutType,
    MessageTypeType,
    ModeType,
    OperatorType,
    RecencyTypeType,
    SegmentTypeType,
    SourceTypeType,
    StateType,
    TemplateTypeType,
    TypeType,
    PinpointServiceName,
    ServiceName,
    ResourceServiceName,
    RegionName,
)

def check_value(value: ActionType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_pinpoint.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_pinpoint.type_defs import (
    ADMChannelRequestTypeDef,
    ADMChannelResponseTypeDef,
    ADMMessageTypeDef,
    APNSChannelRequestTypeDef,
    APNSChannelResponseTypeDef,
    APNSMessageTypeDef,
    APNSPushNotificationTemplateTypeDef,
    APNSSandboxChannelRequestTypeDef,
    APNSSandboxChannelResponseTypeDef,
    APNSVoipChannelRequestTypeDef,
    APNSVoipChannelResponseTypeDef,
    APNSVoipSandboxChannelRequestTypeDef,
    APNSVoipSandboxChannelResponseTypeDef,
    ActivitiesResponseTypeDef,
    ActivityResponseTypeDef,
    ActivityTypeDef,
    AddressConfigurationTypeDef,
    AndroidPushNotificationTemplateTypeDef,
    ApplicationDateRangeKpiResponseTypeDef,
    ApplicationResponseTypeDef,
    ApplicationSettingsResourceTypeDef,
    ApplicationsResponseTypeDef,
    AttributeDimensionTypeDef,
    AttributesResourceTypeDef,
    BaiduChannelRequestTypeDef,
    BaiduChannelResponseTypeDef,
    BaiduMessageTypeDef,
    BaseKpiResultTypeDef,
    CampaignCustomMessageTypeDef,
    CampaignDateRangeKpiResponseTypeDef,
    CampaignEmailMessageTypeDef,
    CampaignEventFilterTypeDef,
    CampaignHookTypeDef,
    CampaignInAppMessageTypeDef,
    CampaignLimitsTypeDef,
    CampaignResponseTypeDef,
    CampaignSmsMessageTypeDef,
    CampaignStateTypeDef,
    CampaignsResponseTypeDef,
    ChannelResponseTypeDef,
    ChannelsResponseTypeDef,
    ConditionTypeDef,
    ConditionalSplitActivityTypeDef,
    ContactCenterActivityTypeDef,
    CreateAppRequestRequestTypeDef,
    CreateAppResponseTypeDef,
    CreateApplicationRequestTypeDef,
    CreateCampaignRequestRequestTypeDef,
    CreateCampaignResponseTypeDef,
    CreateEmailTemplateRequestRequestTypeDef,
    CreateEmailTemplateResponseTypeDef,
    CreateExportJobRequestRequestTypeDef,
    CreateExportJobResponseTypeDef,
    CreateImportJobRequestRequestTypeDef,
    CreateImportJobResponseTypeDef,
    CreateInAppTemplateRequestRequestTypeDef,
    CreateInAppTemplateResponseTypeDef,
    CreateJourneyRequestRequestTypeDef,
    CreateJourneyResponseTypeDef,
    CreatePushTemplateRequestRequestTypeDef,
    CreatePushTemplateResponseTypeDef,
    CreateRecommenderConfigurationRequestRequestTypeDef,
    CreateRecommenderConfigurationResponseTypeDef,
    CreateRecommenderConfigurationTypeDef,
    CreateSegmentRequestRequestTypeDef,
    CreateSegmentResponseTypeDef,
    CreateSmsTemplateRequestRequestTypeDef,
    CreateSmsTemplateResponseTypeDef,
    CreateTemplateMessageBodyTypeDef,
    CreateVoiceTemplateRequestRequestTypeDef,
    CreateVoiceTemplateResponseTypeDef,
    CustomDeliveryConfigurationTypeDef,
    CustomMessageActivityTypeDef,
    DefaultButtonConfigurationTypeDef,
    DefaultMessageTypeDef,
    DefaultPushNotificationMessageTypeDef,
    DefaultPushNotificationTemplateTypeDef,
    DeleteAdmChannelRequestRequestTypeDef,
    DeleteAdmChannelResponseTypeDef,
    DeleteApnsChannelRequestRequestTypeDef,
    DeleteApnsChannelResponseTypeDef,
    DeleteApnsSandboxChannelRequestRequestTypeDef,
    DeleteApnsSandboxChannelResponseTypeDef,
    DeleteApnsVoipChannelRequestRequestTypeDef,
    DeleteApnsVoipChannelResponseTypeDef,
    DeleteApnsVoipSandboxChannelRequestRequestTypeDef,
    DeleteApnsVoipSandboxChannelResponseTypeDef,
    DeleteAppRequestRequestTypeDef,
    DeleteAppResponseTypeDef,
    DeleteBaiduChannelRequestRequestTypeDef,
    DeleteBaiduChannelResponseTypeDef,
    DeleteCampaignRequestRequestTypeDef,
    DeleteCampaignResponseTypeDef,
    DeleteEmailChannelRequestRequestTypeDef,
    DeleteEmailChannelResponseTypeDef,
    DeleteEmailTemplateRequestRequestTypeDef,
    DeleteEmailTemplateResponseTypeDef,
    DeleteEndpointRequestRequestTypeDef,
    DeleteEndpointResponseTypeDef,
    DeleteEventStreamRequestRequestTypeDef,
    DeleteEventStreamResponseTypeDef,
    DeleteGcmChannelRequestRequestTypeDef,
    DeleteGcmChannelResponseTypeDef,
    DeleteInAppTemplateRequestRequestTypeDef,
    DeleteInAppTemplateResponseTypeDef,
    DeleteJourneyRequestRequestTypeDef,
    DeleteJourneyResponseTypeDef,
    DeletePushTemplateRequestRequestTypeDef,
    DeletePushTemplateResponseTypeDef,
    DeleteRecommenderConfigurationRequestRequestTypeDef,
    DeleteRecommenderConfigurationResponseTypeDef,
    DeleteSegmentRequestRequestTypeDef,
    DeleteSegmentResponseTypeDef,
    DeleteSmsChannelRequestRequestTypeDef,
    DeleteSmsChannelResponseTypeDef,
    DeleteSmsTemplateRequestRequestTypeDef,
    DeleteSmsTemplateResponseTypeDef,
    DeleteUserEndpointsRequestRequestTypeDef,
    DeleteUserEndpointsResponseTypeDef,
    DeleteVoiceChannelRequestRequestTypeDef,
    DeleteVoiceChannelResponseTypeDef,
    DeleteVoiceTemplateRequestRequestTypeDef,
    DeleteVoiceTemplateResponseTypeDef,
    DirectMessageConfigurationTypeDef,
    EmailChannelRequestTypeDef,
    EmailChannelResponseTypeDef,
    EmailMessageActivityTypeDef,
    EmailMessageTypeDef,
    EmailTemplateRequestTypeDef,
    EmailTemplateResponseTypeDef,
    EndpointBatchItemTypeDef,
    EndpointBatchRequestTypeDef,
    EndpointDemographicTypeDef,
    EndpointItemResponseTypeDef,
    EndpointLocationTypeDef,
    EndpointMessageResultTypeDef,
    EndpointRequestTypeDef,
    EndpointResponseTypeDef,
    EndpointSendConfigurationTypeDef,
    EndpointUserTypeDef,
    EndpointsResponseTypeDef,
    EventConditionTypeDef,
    EventDimensionsTypeDef,
    EventFilterTypeDef,
    EventItemResponseTypeDef,
    EventStartConditionTypeDef,
    EventStreamTypeDef,
    EventTypeDef,
    EventsBatchTypeDef,
    EventsRequestTypeDef,
    EventsResponseTypeDef,
    ExportJobRequestTypeDef,
    ExportJobResourceTypeDef,
    ExportJobResponseTypeDef,
    ExportJobsResponseTypeDef,
    GCMChannelRequestTypeDef,
    GCMChannelResponseTypeDef,
    GCMMessageTypeDef,
    GPSCoordinatesTypeDef,
    GPSPointDimensionTypeDef,
    GetAdmChannelRequestRequestTypeDef,
    GetAdmChannelResponseTypeDef,
    GetApnsChannelRequestRequestTypeDef,
    GetApnsChannelResponseTypeDef,
    GetApnsSandboxChannelRequestRequestTypeDef,
    GetApnsSandboxChannelResponseTypeDef,
    GetApnsVoipChannelRequestRequestTypeDef,
    GetApnsVoipChannelResponseTypeDef,
    GetApnsVoipSandboxChannelRequestRequestTypeDef,
    GetApnsVoipSandboxChannelResponseTypeDef,
    GetAppRequestRequestTypeDef,
    GetAppResponseTypeDef,
    GetApplicationDateRangeKpiRequestRequestTypeDef,
    GetApplicationDateRangeKpiResponseTypeDef,
    GetApplicationSettingsRequestRequestTypeDef,
    GetApplicationSettingsResponseTypeDef,
    GetAppsRequestRequestTypeDef,
    GetAppsResponseTypeDef,
    GetBaiduChannelRequestRequestTypeDef,
    GetBaiduChannelResponseTypeDef,
    GetCampaignActivitiesRequestRequestTypeDef,
    GetCampaignActivitiesResponseTypeDef,
    GetCampaignDateRangeKpiRequestRequestTypeDef,
    GetCampaignDateRangeKpiResponseTypeDef,
    GetCampaignRequestRequestTypeDef,
    GetCampaignResponseTypeDef,
    GetCampaignVersionRequestRequestTypeDef,
    GetCampaignVersionResponseTypeDef,
    GetCampaignVersionsRequestRequestTypeDef,
    GetCampaignVersionsResponseTypeDef,
    GetCampaignsRequestRequestTypeDef,
    GetCampaignsResponseTypeDef,
    GetChannelsRequestRequestTypeDef,
    GetChannelsResponseTypeDef,
    GetEmailChannelRequestRequestTypeDef,
    GetEmailChannelResponseTypeDef,
    GetEmailTemplateRequestRequestTypeDef,
    GetEmailTemplateResponseTypeDef,
    GetEndpointRequestRequestTypeDef,
    GetEndpointResponseTypeDef,
    GetEventStreamRequestRequestTypeDef,
    GetEventStreamResponseTypeDef,
    GetExportJobRequestRequestTypeDef,
    GetExportJobResponseTypeDef,
    GetExportJobsRequestRequestTypeDef,
    GetExportJobsResponseTypeDef,
    GetGcmChannelRequestRequestTypeDef,
    GetGcmChannelResponseTypeDef,
    GetImportJobRequestRequestTypeDef,
    GetImportJobResponseTypeDef,
    GetImportJobsRequestRequestTypeDef,
    GetImportJobsResponseTypeDef,
    GetInAppMessagesRequestRequestTypeDef,
    GetInAppMessagesResponseTypeDef,
    GetInAppTemplateRequestRequestTypeDef,
    GetInAppTemplateResponseTypeDef,
    GetJourneyDateRangeKpiRequestRequestTypeDef,
    GetJourneyDateRangeKpiResponseTypeDef,
    GetJourneyExecutionActivityMetricsRequestRequestTypeDef,
    GetJourneyExecutionActivityMetricsResponseTypeDef,
    GetJourneyExecutionMetricsRequestRequestTypeDef,
    GetJourneyExecutionMetricsResponseTypeDef,
    GetJourneyRequestRequestTypeDef,
    GetJourneyResponseTypeDef,
    GetPushTemplateRequestRequestTypeDef,
    GetPushTemplateResponseTypeDef,
    GetRecommenderConfigurationRequestRequestTypeDef,
    GetRecommenderConfigurationResponseTypeDef,
    GetRecommenderConfigurationsRequestRequestTypeDef,
    GetRecommenderConfigurationsResponseTypeDef,
    GetSegmentExportJobsRequestRequestTypeDef,
    GetSegmentExportJobsResponseTypeDef,
    GetSegmentImportJobsRequestRequestTypeDef,
    GetSegmentImportJobsResponseTypeDef,
    GetSegmentRequestRequestTypeDef,
    GetSegmentResponseTypeDef,
    GetSegmentVersionRequestRequestTypeDef,
    GetSegmentVersionResponseTypeDef,
    GetSegmentVersionsRequestRequestTypeDef,
    GetSegmentVersionsResponseTypeDef,
    GetSegmentsRequestRequestTypeDef,
    GetSegmentsResponseTypeDef,
    GetSmsChannelRequestRequestTypeDef,
    GetSmsChannelResponseTypeDef,
    GetSmsTemplateRequestRequestTypeDef,
    GetSmsTemplateResponseTypeDef,
    GetUserEndpointsRequestRequestTypeDef,
    GetUserEndpointsResponseTypeDef,
    GetVoiceChannelRequestRequestTypeDef,
    GetVoiceChannelResponseTypeDef,
    GetVoiceTemplateRequestRequestTypeDef,
    GetVoiceTemplateResponseTypeDef,
    HoldoutActivityTypeDef,
    ImportJobRequestTypeDef,
    ImportJobResourceTypeDef,
    ImportJobResponseTypeDef,
    ImportJobsResponseTypeDef,
    InAppCampaignScheduleTypeDef,
    InAppMessageBodyConfigTypeDef,
    InAppMessageButtonTypeDef,
    InAppMessageCampaignTypeDef,
    InAppMessageContentTypeDef,
    InAppMessageHeaderConfigTypeDef,
    InAppMessageTypeDef,
    InAppMessagesResponseTypeDef,
    InAppTemplateRequestTypeDef,
    InAppTemplateResponseTypeDef,
    ItemResponseTypeDef,
    JourneyChannelSettingsTypeDef,
    JourneyCustomMessageTypeDef,
    JourneyDateRangeKpiResponseTypeDef,
    JourneyEmailMessageTypeDef,
    JourneyExecutionActivityMetricsResponseTypeDef,
    JourneyExecutionMetricsResponseTypeDef,
    JourneyLimitsTypeDef,
    JourneyPushMessageTypeDef,
    JourneyResponseTypeDef,
    JourneySMSMessageTypeDef,
    JourneyScheduleTypeDef,
    JourneyStateRequestTypeDef,
    JourneysResponseTypeDef,
    ListJourneysRequestRequestTypeDef,
    ListJourneysResponseTypeDef,
    ListRecommenderConfigurationsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListTemplateVersionsRequestRequestTypeDef,
    ListTemplateVersionsResponseTypeDef,
    ListTemplatesRequestRequestTypeDef,
    ListTemplatesResponseTypeDef,
    MessageBodyTypeDef,
    MessageConfigurationTypeDef,
    MessageRequestTypeDef,
    MessageResponseTypeDef,
    MessageResultTypeDef,
    MessageTypeDef,
    MetricDimensionTypeDef,
    MultiConditionalBranchTypeDef,
    MultiConditionalSplitActivityTypeDef,
    NumberValidateRequestTypeDef,
    NumberValidateResponseTypeDef,
    OverrideButtonConfigurationTypeDef,
    PhoneNumberValidateRequestRequestTypeDef,
    PhoneNumberValidateResponseTypeDef,
    PublicEndpointTypeDef,
    PushMessageActivityTypeDef,
    PushNotificationTemplateRequestTypeDef,
    PushNotificationTemplateResponseTypeDef,
    PutEventStreamRequestRequestTypeDef,
    PutEventStreamResponseTypeDef,
    PutEventsRequestRequestTypeDef,
    PutEventsResponseTypeDef,
    QuietTimeTypeDef,
    RandomSplitActivityTypeDef,
    RandomSplitEntryTypeDef,
    RawEmailTypeDef,
    RecencyDimensionTypeDef,
    RecommenderConfigurationResponseTypeDef,
    RemoveAttributesRequestRequestTypeDef,
    RemoveAttributesResponseTypeDef,
    ResponseMetadataTypeDef,
    ResultRowTypeDef,
    ResultRowValueTypeDef,
    SMSChannelRequestTypeDef,
    SMSChannelResponseTypeDef,
    SMSMessageActivityTypeDef,
    SMSMessageTypeDef,
    SMSTemplateRequestTypeDef,
    SMSTemplateResponseTypeDef,
    ScheduleTypeDef,
    SegmentBehaviorsTypeDef,
    SegmentConditionTypeDef,
    SegmentDemographicsTypeDef,
    SegmentDimensionsTypeDef,
    SegmentGroupListTypeDef,
    SegmentGroupTypeDef,
    SegmentImportResourceTypeDef,
    SegmentLocationTypeDef,
    SegmentReferenceTypeDef,
    SegmentResponseTypeDef,
    SegmentsResponseTypeDef,
    SendMessagesRequestRequestTypeDef,
    SendMessagesResponseTypeDef,
    SendOTPMessageRequestParametersTypeDef,
    SendOTPMessageRequestRequestTypeDef,
    SendOTPMessageResponseTypeDef,
    SendUsersMessageRequestTypeDef,
    SendUsersMessageResponseTypeDef,
    SendUsersMessagesRequestRequestTypeDef,
    SendUsersMessagesResponseTypeDef,
    SessionTypeDef,
    SetDimensionTypeDef,
    SimpleConditionTypeDef,
    SimpleEmailPartTypeDef,
    SimpleEmailTypeDef,
    StartConditionTypeDef,
    TagResourceRequestRequestTypeDef,
    TagsModelTypeDef,
    TemplateActiveVersionRequestTypeDef,
    TemplateConfigurationTypeDef,
    TemplateCreateMessageBodyTypeDef,
    TemplateResponseTypeDef,
    TemplateTypeDef,
    TemplateVersionResponseTypeDef,
    TemplateVersionsResponseTypeDef,
    TemplatesResponseTypeDef,
    TreatmentResourceTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAdmChannelRequestRequestTypeDef,
    UpdateAdmChannelResponseTypeDef,
    UpdateApnsChannelRequestRequestTypeDef,
    UpdateApnsChannelResponseTypeDef,
    UpdateApnsSandboxChannelRequestRequestTypeDef,
    UpdateApnsSandboxChannelResponseTypeDef,
    UpdateApnsVoipChannelRequestRequestTypeDef,
    UpdateApnsVoipChannelResponseTypeDef,
    UpdateApnsVoipSandboxChannelRequestRequestTypeDef,
    UpdateApnsVoipSandboxChannelResponseTypeDef,
    UpdateApplicationSettingsRequestRequestTypeDef,
    UpdateApplicationSettingsResponseTypeDef,
    UpdateAttributesRequestTypeDef,
    UpdateBaiduChannelRequestRequestTypeDef,
    UpdateBaiduChannelResponseTypeDef,
    UpdateCampaignRequestRequestTypeDef,
    UpdateCampaignResponseTypeDef,
    UpdateEmailChannelRequestRequestTypeDef,
    UpdateEmailChannelResponseTypeDef,
    UpdateEmailTemplateRequestRequestTypeDef,
    UpdateEmailTemplateResponseTypeDef,
    UpdateEndpointRequestRequestTypeDef,
    UpdateEndpointResponseTypeDef,
    UpdateEndpointsBatchRequestRequestTypeDef,
    UpdateEndpointsBatchResponseTypeDef,
    UpdateGcmChannelRequestRequestTypeDef,
    UpdateGcmChannelResponseTypeDef,
    UpdateInAppTemplateRequestRequestTypeDef,
    UpdateInAppTemplateResponseTypeDef,
    UpdateJourneyRequestRequestTypeDef,
    UpdateJourneyResponseTypeDef,
    UpdateJourneyStateRequestRequestTypeDef,
    UpdateJourneyStateResponseTypeDef,
    UpdatePushTemplateRequestRequestTypeDef,
    UpdatePushTemplateResponseTypeDef,
    UpdateRecommenderConfigurationRequestRequestTypeDef,
    UpdateRecommenderConfigurationResponseTypeDef,
    UpdateRecommenderConfigurationTypeDef,
    UpdateSegmentRequestRequestTypeDef,
    UpdateSegmentResponseTypeDef,
    UpdateSmsChannelRequestRequestTypeDef,
    UpdateSmsChannelResponseTypeDef,
    UpdateSmsTemplateRequestRequestTypeDef,
    UpdateSmsTemplateResponseTypeDef,
    UpdateTemplateActiveVersionRequestRequestTypeDef,
    UpdateTemplateActiveVersionResponseTypeDef,
    UpdateVoiceChannelRequestRequestTypeDef,
    UpdateVoiceChannelResponseTypeDef,
    UpdateVoiceTemplateRequestRequestTypeDef,
    UpdateVoiceTemplateResponseTypeDef,
    VerificationResponseTypeDef,
    VerifyOTPMessageRequestParametersTypeDef,
    VerifyOTPMessageRequestRequestTypeDef,
    VerifyOTPMessageResponseTypeDef,
    VoiceChannelRequestTypeDef,
    VoiceChannelResponseTypeDef,
    VoiceMessageTypeDef,
    VoiceTemplateRequestTypeDef,
    VoiceTemplateResponseTypeDef,
    WaitActivityTypeDef,
    WaitTimeTypeDef,
    WriteApplicationSettingsRequestTypeDef,
    WriteCampaignRequestTypeDef,
    WriteEventStreamTypeDef,
    WriteJourneyRequestTypeDef,
    WriteSegmentRequestTypeDef,
    WriteTreatmentResourceTypeDef,
)

def get_structure() -> ADMChannelRequestTypeDef:
    return {
      ...
    }
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/vemel/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-pinpoint` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
